import { Component, Prop, Vue } from "vue-property-decorator";

@Component({
  name: "componentsAreaSelect",
})
export default class extends Vue {
  @Prop({
    default: () => {
      return [];
    },
  })
  hotCity!: any[]; //热门城市
  @Prop({
    default: () => {
      return [];
    },
  })
  districtData!: any[]; //区县
  @Prop({ default: "" }) siteCity!: string; //当前城市

  aeraList = require("../../static/city.json");
  cities = this.aeraList.data.cities; //城市列表
  hotcites = this.hotCity; //热门城市
  district = this.districtData;
  toIndex = ""; //跳转的索引的字母
  letterDetails = <any[]>[];
  currentLetter = "area";
  tipsLetter = ""; //滑动显示字母
  isToggle = false;
  inputValue = "";
  searchData = []; //搜索的数据
  hasNoData = false;
  timer = 0;
  site = this.siteCity;
  onLoad() {
    // console.log(this.aeraList);
  }
  scrollHandle(e: any) {
    const view: any = uni.createSelectorQuery().in(this).selectAll(".list-item"); //获取需要定位的节点
    view
      .boundingClientRect((data: any) => {
        //通过uni提供的方法拿到节点里的属性
        const top = data[0].top;
        data.forEach((item: any) => {
          item.top = item.top - top;
          item.bottom = item.bottom - top;
          this.letterDetails.push({
            id: item.id,
            top: item.top,
            bottom: item.bottom,
          });
        });
        const scrollTop = e.detail.scrollTop;
        this.letterDetails.some((item) => {
          if (scrollTop >= item.top && scrollTop <= item.bottom) {
            this.currentLetter = item.id;
            return true;
          }
        });
      })
      .exec();
  }
  //提示字母转换
  letterTransform(letter: any) {
    let str = "";
    if (letter == "area") {
      str = "区县";
    } else if (letter == "hot") {
      str = "热门";
    } else {
      str = letter;
    }
    return str;
  }
  //移动开始获取字母，并放大提示
  getLetter(e: any) {
    // 添加手机震动回馈
    uni.vibrateShort({
      success: function () {
        console.log("success");
      },
    });
    const { id } = e.currentTarget;
    this.tipsLetter = id;
    const curentLetter = this.letterTransform(id);
    uni.showToast({
      title: curentLetter,
      icon: "none",
      duration: 1000,
    });
  }
  //点击触发结束
  setLetter() {
    this.toIndex = this.tipsLetter;
  }
  // 移动触发开始
  touchStart(e: any) {
    console.log(e);
  }
  // 开始移动
  touchMove(e: any) {
    const moveTop = e.currentTarget.offsetTop; // 距离顶部的移动距离
    const clientY = e.touches[0].clientY; //点击停留位置的Y坐标
    // 如果滑动坐标距离大于顶部距离执行
    if (clientY > moveTop) {
      // 坐标距离减去顶部距离拿到字母开始到最后手指停留的位置，除以字母的高度拿到最后一个字母的位置
      const indx = parseInt(((clientY - moveTop) / 13).toString(), 10);
      // 承接一下字母的ID
      const letter = this.aeraList.data.alphabet[indx];
      this.tipsLetter = letter;
      const curentLetter = this.letterTransform(letter);
      uni.showToast({
        title: curentLetter,
        icon: "none",
        duration: 1000,
      });
    }
    // 添加手机震动回馈
    uni.vibrateShort({
      success: function () {
        console.log("success");
      },
    });
  }
  touchEnd() {
    this.toIndex = this.tipsLetter;
  }
  //搜索
  searchChange(e: any) {
    const { value } = e.detail;
    this.inputValue = value;
    if (this.timer) {
      clearTimeout(this.timer);
    }

    if (!this.inputValue) {
      this.searchData = [];
      return;
    }
    this.timer = setTimeout(() => {
      const result: any = [];
      for (const i in this.cities) {
        this.cities[i].forEach((item: any) => {
          if (item.name.includes(this.inputValue) || (item.spell && item.spell.includes(this.inputValue))) {
            result.push(item);
          }
        });
      }
      this.searchData = result;
      console.log(this.searchData);
      if (this.searchData.length === 0) {
        this.hasNoData = true;
      } else {
        this.hasNoData = false;
      }
    }, 500);
  }
  //搜索列表选中事件
  citySearchList(item: any) {
    console.log(item);
    this.$emit("citySearchList", item);
  }
  //城市列表选中事件
  getCityList(item: any) {
    console.log(item);
    this.$emit("getCityList", item);
  }
  //热门城市选中事件
  getHotcity(item: any) {
    console.log(item);
    this.$emit("getHotcity", item);
  }
  //切换区县城市选中事件
  getCutcity(item: any) {
    console.log(item);
    this.$emit("getCutcity", item);
  }
}
