import { Component, Vue, Prop } from "vue-property-decorator";
import { getCityList } from "@/api/app";
// import openMerchantCardList = my.openMerchantCardList;

@Component({
  name: "newCityList",
})
export default class extends Vue {
  @Prop({
    default: () => {
      return [];
    },
  })
  areaLists!: any[]; // 省份
  @Prop({
    default: () => {
      return [];
    },
  })
  city!: any[]; //城市

  @Prop({ default: "" }) siteCity!: string;
  @Prop({ default: 20 }) limitNum!: number;

  aeraList = require("../../static/city.json");
  cities = this.aeraList.data.cities; //城市列表
  pid = 0;
  areaList = this.areaLists;
  cityList = this.city;
  state = false;
  addCityList = <any[]>[]; //选中的城市集合
  leftIndex = 0;
  numList = <any[]>[]; // 左侧展示的选中城市数量
  reg = (val: any) => {
    return val.replace(/省|市|自治区|特别行政区|壮族|回族|维吾尔/g, "");
  };
  site = this.siteCity; // 当前定位的城市
  lentNum = this.limitNum; //限制选中城市的数量
  listData = <any[]>[];

  created() {
    getCityList({ pid: this.pid }).then((res: any) => {
      this.areaList = res.data;
      this.areaList.forEach((item: any) => {
        uni.removeStorageSync(item.id.toString());
      });
    });
  }

  getStorage(item: any) {
    return uni.getStorageSync(item.id.toString());
  }
  getStorageNum(item: any) {
    return uni.getStorageSync(item.id.toString()).length;
  }

  //左侧省切换
  getCitys(val: any, index: number) {
    this.leftIndex = index;
    this.numList = [];
    this.listData = [];
    const arr = [];
    getCityList({ pid: val.id }).then((item: any) => {
      this.cityList = item.data;
      this.cityList.forEach((item: any) => {
        const obj = this.addCityList.find((val: any) => {
          return val.id === item.id;
        });
        if (obj) {
          arr.push(obj);
          if (arr.length === this.cityList.length) {
            this.state = true;
          } else {
            this.state = false;
          }
          item.state = true;
          this.numList.push(obj);
          this.listData.push(obj.id);
        } else {
          item.state = false;
          this.state = false;
        }
      });
    });
  }
  // 全选
  allCheck() {
    if (this.addCityList.length === this.lentNum) {
      console.log("未被清空");
    } else {
      this.numList = [];
      this.listData = [];
    }
    this.cityList.forEach((item: any) => {
      this.addCityList.push(item);
      const obj: any = {};
      this.addCityList = this.addCityList.reduce((newArr, next) => {
        obj[next.id] ? "" : (obj[next.id] = true && newArr.push(next));
        return newArr;
      }, []);
      console.log(this.addCityList);
      if (this.addCityList.length <= this.lentNum) {
        item.state = true;
        this.numList.push(item);
        this.listData.push(item.id);
        uni.setStorageSync(item.parentId.toString(), [...new Set(this.listData)]);
        if (this.numList.length === this.cityList.length) {
          this.state = true;
        } else {
          this.state = false;
        }
      } else {
        this.addCityList.splice(this.lentNum, this.addCityList.length - this.lentNum);
        const indexNum = this.addCityList.find((val: any) => item.id === val.id);
        if (indexNum) {
          item.state = true;
        } else {
          item.state = false;
        }
        uni.showToast({
          title: `最多选择城市为${this.lentNum}`,
          icon: "none",
          duration: 1000,
        });
      }
    });
  }
  // 取消全选
  closeCheck() {
    this.numList = [];
    if (this.addCityList.length <= this.lentNum) {
      this.state = false;
      this.cityList.forEach((item: any) => {
        item.state = false;
        this.listData = [];
        uni.setStorageSync(item.parentId.toString(), this.listData);
        if (uni.getStorageSync(item.parentId.toString()).length === 0) {
          uni.removeStorageSync(item.parentId.toString());
        }
        const ind = this.addCityList.find((val: any) => item.id === val.id);
        if (ind) {
          this.addCityList = this.addCityList.filter((item: any) => {
            return item.id !== ind.id;
          });
        }
      });
    } else {
      uni.showToast({
        title: `最多选择城市为${this.lentNum}`,
        icon: "none",
        duration: 1000,
      });
      return;
    }
  }
  // 点击选择
  addData(item: any) {
    this.$nextTick(() => {
      if (this.addCityList.length >= this.lentNum && item.state === false) {
        uni.showToast({
          title: `最多选择城市为${this.lentNum}`,
          icon: "none",
          duration: 1000,
        });
        this.addCityList.splice(this.lentNum, this.addCityList.length - this.lentNum);
      } else {
        item.state = !item.state;
        if (item.state === true) {
          this.addCityList.push(item);
          this.numList.push(item);
          this.listData.push(item.id);
          uni.setStorageSync(item.parentId.toString(), [...new Set(this.listData)]);
        } else {
          const ind = this.addCityList.indexOf(this.addCityList.find((val: any) => item.id === val.id));
          this.addCityList.splice(ind, 1);
          this.numList.splice(this.numList.indexOf(this.numList.find((val: any) => item.id === val.id)), 1);
          this.listData.splice(this.listData.indexOf(this.listData.find((val: any) => item.id === val)), 1);
          uni.setStorageSync(item.parentId.toString(), this.listData);
          if (uni.getStorageSync(item.parentId.toString()).length === 0) {
            uni.removeStorageSync(item.parentId.toString());
          }
        }
        if (this.numList.length === this.cityList.length) {
          this.state = true;
        } else {
          this.state = false;
        }
      }
    });
  }
  //完成  保存
  saveData() {
    console.log(this.addCityList);
    this.$emit("saveData", this.addCityList);
  }
  //取消
  close() {
    console.log("取消");
    this.$emit("close");
  }
}
