import { Component, Vue, Prop } from "vue-property-decorator";

@Component({
  name: "newPwdVerigfy",
})
export default class extends Vue {
  // 密码框是否展示
  @Prop({ default: true }) whernoshow!: boolean;
  @Prop({ default: true }) popupType!: boolean;
  // 密码长度
  @Prop({ default: 6 }) virtualInputs!: number;
  @Prop({ default: 5 }) sumtotal!: number;
  @Prop({ default: "" }) retlink!: string;
  inputValue = "";
  // 密码
  code = "";
  // 输入不完整提示
  nostanipt = false;
  // 键盘展示
  keyShow = false;
  // 是否重置密码
  replacem = false;
  //验证失败提示
  tipmsg = "";
  // 单个框是否加边框
  isShowBorder = false;
  // 代替popupType
  popupTypes = this.popupType;
  checkType = this.virtualInputs === 6 ? "sixpass" : "safepass";
  cursor = false;
  isIOS = false;
  onload() {
    if (!this.popupType) {
      this.tipmsg = `你今日还可以输入${this.sumtotal}次`;
    }
  }
  // 关闭
  closed() {
    this.whernoshow = false;
    this.$emit("whernoshow", false);
  }
  blurs() {
    this.isShowBorder = false;
  }
  // 重新输入密码
  anew() {
    this.code = "";
    this.popupTypes = true;
  }
  // 键盘
  key(key: any) {
    this.showKeyAndBoard();
    if (this.code.length >= this.virtualInputs) return;
    if (typeof key === "number") {
      if (this.code.length < this.virtualInputs) this.code += key;
    } else {
      // 限制仅可输入一个点，如果无需限制则去掉if条件
      if (!this.code.includes(".")) this.code = String(this.code) + key;
    }
    this.addStylePsw();
  }
  del(ev: any) {
    this.showKeyAndBoard();
    if (this.code.length > 0) {
      this.code = this.code.substring(0, this.code.length - 1);
    }
    const passWordList = document.querySelectorAll(".passWord") as NodeListOf<HTMLElement>;
    passWordList.forEach((item) => {
      if (!item.innerHTML) item.className = "passWord";
    });
    this.addStylePsw();
  }
  // 收起键盘
  packup() {
    this.hideKeyAndBoard();
  }
  codefocus(e: any) {
    this.showKeyAndBoard();
    if (e == this.code.length) {
      this.keyShow = true;
    }
    if (this.code.length === 0) {
      const passWordList = document.querySelectorAll(".passWord") as NodeListOf<HTMLElement>;
      passWordList[0].className = "passWord";
      this.cursor = true;
    }
    this.addStylePsw();
  }
  // 获取六位密码框焦点
  fccs(i: any) {
    this.isShowBorder = true;
  }
  getPassword() {
    if (this.code.length < this.virtualInputs) {
      this.nostanipt = true;
    }
    if (this.code.length === this.virtualInputs) {
      this.nostanipt = false;
      this.$emit("getPassword", this.inputValue);
      this.keyShow = false;
      this.popupTypes = false;
      if (this.sumtotal > 0) this.tipmsg = `你今日还可以输入${this.sumtotal}次`;
      if (this.sumtotal < 1) {
        this.replacem = true;
        this.tipmsg = "请重置您的安全密码";
      }
    }
  }
  // 忘记
  forget() {
    window.open(`${process.env.VUE_APP_chat}html/security/index.html?needSafe=1&retUrl=${this.retlink}`);
  }
  // 键盘展示且展示边框
  showKeyAndBoard() {
    this.keyShow = true;
    this.isShowBorder = true;
  }
  hideKeyAndBoard() {
    this.keyShow = false;
    this.isShowBorder = false;
  }
  // 六位数字给修改最后一个
  addStylePsw() {
    const len = this.code.length;
    if (this.checkType === "sixpass") {
      const passWordList = document.querySelectorAll(".passWord") as NodeListOf<HTMLElement>;
      passWordList.forEach((item, index) => {
        if (index < len) {
          item.className = "showBorders passWord";
          if (index < passWordList.length - 1) {
            passWordList[index + 1].className = "showBorders passWord fillFont";
          }
        }
        index > len && (item.className = "passWord");
      });
      if (!this.code.length) passWordList[0].className = "showBorders passWord fillFont";
    }
  }
}
