import Vue from "vue";
import axios from "axios";
import store from "./store";
import App from "./App.vue";
import "./static/scss/global.scss";

import areaSelect from "./components/area-select/area-select.vue";
import upAareaSelect from "./components/up-area-select/up-area-select.vue";
import multipleCities from "./components/multiple-cities/multiple-cities.vue";
import pwdVerify from "./components/pwd-verify/pwd-verify.vue";

export { areaSelect, upAareaSelect, multipleCities, pwdVerify };

// eslint-disable-next-line @typescript-eslint/no-var-requires
const settle = require("axios/lib/core/settle");
// eslint-disable-next-line @typescript-eslint/no-var-requires
const buildURL = require("axios/lib/helpers/buildURL");

Vue.config.productionTip = false;

axios.defaults.adapter = function (config) {
  return new Promise((resolve, reject) => {
    uni.request({
      method: (config.method || "GET").toUpperCase() as "GET",
      url: `${config.baseURL}${buildURL(config.url, config.params, config.paramsSerializer)}`,
      header: config.headers,
      data: config.data,
      dataType: config.responseType || "",
      responseType: config.responseType,
      complete: function complete(response: any) {
        settle(resolve, reject, {
          data: response.data,
          status: response.statusCode,
          errMsg: response.errMsg,
          header: response.header,
          config: config,
        });
      },
    });
  });
};

Vue.prototype.$store = store;

const app = new (typeof App === "object" ? Vue.extend(Object.assign({ mpType: "app" }, App)) : App)();
app.$mount();
