import axios from "axios";
const { VUE_APP_api, VUE_APP_casUid, VUE_APP_systemId } = process.env;

const service = axios.create({
  baseURL: VUE_APP_api,
  withCredentials: true,
  headers: {
    systemId: VUE_APP_systemId,
    "Cache-Control": "no-cache",
  },
});

service.interceptors.request.use(
  (config) => {
    VUE_APP_casUid === "_cas_uid" && console.log("request", config);

    const miniprogram_uid = uni.getStorageSync(VUE_APP_casUid) || "";
    if (miniprogram_uid) {
      config.headers = {
        Cookie: `${VUE_APP_casUid}=${miniprogram_uid}`,
      };
    }

    const { uid } = uni.getStorageSync("nx-login-data") || {};
    if (uid) {
      config.headers = {
        nxinArchiveUnionId: uid,
      };
    }

    return config;
  },
  (error) => {
    Promise.reject(error);
  }
);

service.interceptors.response.use(
  (response) => {
    const { data } = response;
    VUE_APP_casUid === "_cas_uid" && console.log("responseData", data);

    return data;
  },
  (error) => {
    return Promise.reject(error);
  }
);

export default service;
