export const uuid = (): string => {
  const idArr: string[] = [];
  const hexDigits = "3ba3daa3d648dca5";
  for (let i = 0; i < 32; i++) {
    idArr[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  idArr[14] = "4";
  idArr[19] = hexDigits.substr((Number(idArr[19]) & 0x3) | 0x8, 1);

  const uuid = idArr.join("");
  return uuid;
};

export const moneyFormat = (money = 0, toFixed = 2): string => {
  const numMoney = Number(money);
  if (isNaN(numMoney)) {
    return "0.00";
  }
  return numMoney.toFixed(toFixed);
};

export const dateFormat = (date: Date, formatArg: string): string => {
  let format = formatArg;
  const newDate = new Date(date);
  const object: {
    [key: string]: number;
  } = {
    "M+": newDate.getMonth() + 1,
    "d+": newDate.getDate(),
    "H+": newDate.getHours(),
    "m+": newDate.getMinutes(),
    "s+": newDate.getSeconds(),
    "q+": Math.floor((newDate.getMonth() + 3) / 3),
    S: newDate.getMilliseconds(),
  };
  if (/(y+)/.test(format)) {
    format = format.replace(RegExp.$1, `${newDate.getFullYear()}`.substr(4 - RegExp.$1.length));
  }
  for (const key in object) {
    if (new RegExp(`(${key})`).test(format)) {
      format = format.replace(
        RegExp.$1,
        RegExp.$1.length === 1 ? String(object[key]) : `00${object[key]}`.substr(`${object[key]}`.length)
      );
    }
  }
  return format;
};
